
# eth2 is static.
service net/eth2 {
    depends = system/initial system/checkroot system/modules
    use = system/static-modules system/coldplug
    start {
	echo "Starting net/$NAME now"
	ifconfig $NAME 192.168.4.44 netmask 255.255.255.0
	route add -net 0.0.0.0 gw 192.168.4.1
    }
    stop {
	echo "Stopping net/$NAME now"
	ifconfig $NAME down
    }
}    

# all other, use dns.
service net/eth* {
    depends = system/initial system/checkroot system/modules system/static-modules
    daemon = /sbin/dhcpcd
    daemon_args = -t 3600 $NAME
    pid_file = /var/run/dhcpcd-$NAME.pid
    up_when = pid_set
    #respawn = yes
    stop {
	echo "Stopping net/$NAME now"
	ifconfig $NAME down
	dhcpcd -k $NAME
    }
}    
