
#	need localmount
#	need keymaps    # sets up terminal encoding scheme
#	after hotplug

service system/consolefont {
	depends = system/initial system/keymaps
start {
#/bin/bash
	if [ -f /etc/conf.d/consolefont ]
	then
	    source /etc/conf.d/consolefont
	fi

	if [ -f /etc/rc.conf ]
	then
	    source /etc/rc.conf
	fi

	if [[ -z ${CONSOLEFONT} ]] ; then
		echo "Using the default console font"
		exit 0
	fi

	retval=1
	
	# Get additional parameters
	if [[ -n ${CONSOLETRANSLATION} ]] ; then
		param="-m ${CONSOLETRANSLATION}"
	fi

	# Set the console font
	echo "Setting user font"
	if [[ -x /bin/setfont ]] ; then
		# We patched setfont to have --tty support ...
		if [[ -n $(setfont --help 2>&1 | grep -e '--tty') || \
		      -n $(setfont --help 2>&1 | grep -e '-C') ]]
		then
			if [[ -n $(setfont --help 2>&1 | grep -e '--tty') ]] ; then
				sf_param="--tty="
			else
				sf_param="-C "
			fi
			[[ -d /dev/vc ]] \
				&& ttydev=/dev/vc/ \
				|| ttydev=/dev/tty

			for x in $(seq 1 11) ; do
				/bin/setfont ${CONSOLEFONT} ${param} \
					${sf_param}/${ttydev}${x} >/dev/null
				retval=$?
			done
		else
			/bin/setfont ${CONSOLEFONT} ${param} >/dev/null
			retval=$?
		fi
	else
		retval=1
	fi
	
	exit $retval
}
}

# vim:ts=4
