
service system/static-modules {
	depends = system/initial system/checkroot system/modules
	# system/checkroot
	
start {
    
load_modules() {
	local x=
	local i=0
	local retval=0
	local modules=
	local modargs=
	local modcount=0
	local config="$1"

	[ -z "${config}" ] && return 0
	[ ! -r "${config}" ] && return 0

	# Loop over every line in $config
	eval $(awk '
		BEGIN {
			COUNT = 0 # Make sure COUNT is set
		}

		$0 !~ /(^[[:space:]]*(#|$))/ {
			if (MODULES == "")
				MODULES = $1
			else
				MODULES = MODULES " " $1
			
			# Not the greatest method to remove $1 from $0, but it works
			sub(/^[[:space:]]*[^[:space:]]*[[:space:]]*/, "")
			ARGS[COUNT] = $0
			COUNT++
		}
		
		END {
			# 'eval' will make sure these are set to proper bash variables
			print "modcount=" COUNT
			print "modules=\"" MODULES "\""
			for (x = 0;x < COUNT;x++)
				print "modargs[" x "]=\"" ARGS[x] "\""
		}
	' "${config}")

	if [ "${modcount}" -gt 0 ]
	then
		echo "Using ${config} as config:"
		
		for x in ${modules}
		do
			echo "  Loading module ${x} ..."
			modprobe -q ${x} ${modargs[${i}]} &>/dev/null
			retval=$?
			
			i=$((i+1))
			[ "${retval}" -eq 0 ] || modcount=$((modcount-1))
		done

		echo "Autoloaded ${modcount} module(s)"
	fi

	return 0
}


# Dont probe kernel version, ining, requires 2.6 anyway
load_modules /etc/modules.autoload.d/kernel-2.6


if [ -n "$(modprobe -l -t boot)" ]
then
	modprobe -a -t boot \*  &>/dev/null &
fi
wait

}
}
# vim:ts=4
