
/* Initng, a next generation sysvinit replacement.
 * Copyright (C) 2005 Jimmy Wennlund <jimmy.wennlund@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef INITNG_H
#define INITNG_H

#define DEBUG
#define RUNTIME_DEBUG

/*
 * Temporary printf-replacement macros until a real logging system can be added.
 */
#define F_(fmt, ...)\
    fprintf(stderr, " ** FAIL " __FILE__ ": " fmt, ## __VA_ARGS__ );

#ifdef DEBUG
#ifdef RUNTIME_DEBUG
#define D_(fmt, ...) if(g.verbose) printf(" ** " __FILE__ ": " fmt, ## __VA_ARGS__ );
#else
#define D_(fmt, ...) printf(" ** " __FILE__ ": " fmt, ## __VA_ARGS__ );
#endif
#else
#define D_(fmt, ...)
#endif

#define TRUE    1
#define FALSE   0
#define FAIL    0

#define INITNG_ROOT     "/etc/initng"
#define CONTROL_PATH    "/etc/initng"

#define STD_OUT         "/dev/vc/12"
#define STD_ERR         "/dev/console"

#define INITNG_EXT      ".i"

#define MAX_FILESIZE    10000               /* in bytes */
#define MAX_SERVICE     100
#define MAX_ACTIVE      50

#define HISTORY         400

#define M_D_F           50
#define INITNG_VERSION  "0.0.15 Bug and Plug"

#define INITNG_NICELEVEL -5

#define MAX_MODULES     20
#define MAX_PARSERS     5
#define MAX_STATE_WATCHERS 5

/* printservice adds command -p to ngc, that bloats the console with all data */
#define PRINT_SERVICE
#define MAX_PRINT_LENGTH 60

#endif
