
/* Initng, a next generation sysvinit replacement.
 * Copyright (C) 2005 Jimmy Wennlund <jimmy.wennlund@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef INITNG_HISTORY_H
#define INITNG_HISTORY_H
#include <sys/types.h>
#include "active_status.h"

typedef struct
{
    char *name;
    time_t time;
    e_a_status action;
} history_h;

/*void history_free_this(history_h *this_one); */
void history_free_all(void);
void history_db_init(void);
void history_db_compensate_time(time_t skew);
void history_add(history_h * entry);
void history_add_values(char *name, time_t time, e_a_status action);
history_h *history_get_next(history_h * last);
int time_been_from(char *name, e_a_status from);
#endif
