
/* Initng, a next generation sysvinit replacement.
 * Copyright (C) 2005 Jimmy Wennlund <jimmy.wennlund@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include "initng.h"

#include <sys/types.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <alloca.h>
#include "process_db.h"

/* creats a process_h struct with defaults */
int process_db_new(process_h ** new_p)
{
    /*process_h *new_p=NULL; */

    /* allocate a new process entry */
    *new_p = (process_h *) calloc(1, sizeof(process_h));        /* Allocate memory for a new process */

    /* out of memory? */
    if (!(new_p))
    {
        F_("process_db_new(): Unable to allocate process, out of memory?\n");
        return (FALSE);
    }

#ifdef ZERO_MEMORY
    /* null pid, starttime and status */
    (*new_p)->pid = 0;
#endif
    /* reset resturncode */
    (*new_p)->r_code = -10;

    /* default this */
    (*new_p)->stdin = 0;
    (*new_p)->stdout = 1;

#ifdef ZERO_MEMORY
    /* empty */
    (*new_p)->exec = NULL;
    (*new_p)->exec_args = NULL;
#endif

    return (TRUE);

}

/* function to free a process_h struct */
void process_db_free(process_h ** free_this)
{
    if (!*free_this)
        return;
    free(*free_this);
    *free_this = NULL;
    return;
}
