
/* Initng, a next generation sysvinit replacement.
 * Copyright (C) 2005 Jimmy Wennlund <jimmy.wennlund@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef SERVICE_DB_H
#define SERVICE_DB_H

#include "service_data_types.h"

typedef struct
{
    e_sdt type;
    char *string;
} s_data;

typedef struct
{
    char *name;
    e_type type;
    s_data data[M_D_F];
} service_h;

/*extern service_h **config_database; */

/* data manage functions */
char *service_db_get_string(e_sdt type, service_h * from_service);
char *service_db_get_next_string(e_sdt type, service_h * from_service,
                                 char *last);
void service_db_set_string(e_sdt type, service_h * from_service,
                           char *string);
void service_db_set_another_string(e_sdt type, service_h * from_service,
                                   char *string);
int service_db_is(e_sdt type, service_h * from_service);
void service_db_set(e_sdt type, service_h * from_service);
void service_db_remove(e_sdt type, service_h * from_service);
int service_db_count_type(e_sdt type, service_h * from_service);

/* service haneling functions */
service_h *service_db_add(service_h * s);
int service_db_copy(service_h ** dest, char *name, service_h * s);
int service_db_new(service_h ** d, char *name, e_type type);
service_h *service_db_find_by_name(char *find);
int service_db_free(service_h * to_free);
void service_db_free_all(void);
void service_db_clear_all(void);
int service_db_init(void);
void service_db_change(service_h * from, service_h * to);

#ifdef PRINT_SERVICE
void service_db_print(service_h * s);
void service_db_print_all(void);
#endif

#endif
